'use strict';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _sighCore = require('sigh-core');

var _processPool = require('process-pool');

var _processPool2 = _interopRequireDefault(_processPool);

var _sighLibEvent = require('sigh/lib/Event');

var _sighLibEvent2 = _interopRequireDefault(_sighLibEvent);

var _2 = require('./');

var _3 = _interopRequireDefault(_2);

require('source-map-support').install();
require('chai').should();

describe('babel plugin', function () {
  // TODO: use a single babel plugin for all tests to avoid all the delays due
  //       to starting subprocesses.
  var procPool;
  beforeEach(function () {
    procPool = new _processPool2['default']();
  });
  afterEach(function () {
    procPool.destroy();
  });

  it('compiles a single add event', function () {
    this.timeout(2500);

    var data = 'var pump = () => "pumper"';
    var event = new _sighLibEvent2['default']({
      basePath: 'root',
      path: 'root/subdir/file.js',
      type: 'add',
      data: data
    });
    var stream = _sighCore.Bacon.constant([event]);

    return (0, _3['default'])({ stream: stream, procPool: procPool }).toPromise(_bluebird2['default']).then(function (events) {
      events.length.should.equal(1);

      var _events$0 = events[0];
      var data = _events$0.data;
      var sourceMap = _events$0.sourceMap;

      data.should.equal('define("subdir/file", ["exports"], function (exports) {\n  "use strict";\n\n  var pump = function pump() {\n    return "pumper";\n  };\n});');
      sourceMap.mappings.should.equal(';;;AAAA,MAAI,IAAI,GAAG,SAAP,IAAI;WAAS,QAAQ;GAAA,CAAA');
      sourceMap.file.should.equal(event.path);
    });
  });
});
//# sourceMappingURL=index.spec.js.map